#include <windows.h>
#include <stdio.h>

LRESULT CALLBACK ExamWndProc
     ( HWND hWnd, UINT Message, WPARAM wParam, LPARAM lParam );


int WINAPI WinMain(HINSTANCE hInstance,     //  
                   HINSTANCE hPrevInstance, //   
                   LPSTR lpszCmdParam,      //  
                   int nCmdShow)            //  

{ HWND hWnd;           //  
  WNDCLASS WndClass;   //   
  MSG Msg;             //  ""
  char szClassName[] = "Example1"; //   

  /*    */
  WndClass.style = CS_HREDRAW | CS_VREDRAW; //  
  WndClass.lpfnWndProc = ExamWndProc; //    !
  WndClass.cbClsExtra = 0; //  
  WndClass.cbWndExtra = 0; //  
  WndClass.hInstance = hInstance; //  
  WndClass.hIcon   = LoadIcon(NULL,IDI_APPLICATION); //   
  WndClass.hCursor = LoadCursor(NULL,IDC_ARROW);  //  
  WndClass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); //  
  WndClass.lpszMenuName = NULL; //   
  WndClass.lpszClassName = szClassName; //   

  /*    */
  if (! RegisterClass(&WndClass) )
  {
    MessageBox(NULL,"Cannot register class","Error",MB_OK);
    return 1; //     ,  
  }

  /*   */
  hWnd = CreateWindow(szClassName, //   
  							 "Example N1", //   ( )
                      WS_OVERLAPPEDWINDOW, //  
                      CW_USEDEFAULT, CW_USEDEFAULT, // X,Y 
                      CW_USEDEFAULT, CW_USEDEFAULT, // , 
                      NULL, //   
                      NULL, //   ( )
                      hInstance, //  
                      NULL); //    

 if (!hWnd)
 {
   MessageBox(NULL,"Cannot create Window","Error",MB_OK);
   return 2; //  ,     
 }

 ShowWindow(hWnd,nCmdShow); //   (  )
 UpdateWindow(hWnd); //    WM_PAINT   

 /*       WM_QUIT */
 while (GetMessage(&Msg, //   
                   NULL, //  ,  NULL,     
                   0,0)) //   ( 0,0,  )
 {
  TranslateMessage(&Msg); //     
  DispatchMessage(&Msg);  //  
 }
 return Msg.wParam; //   ,   WM_QUIT
}


/*   */
LRESULT CALLBACK ExamWndProc
     ( HWND hWnd,     //  ,   
       UINT Message,  //  
       WPARAM wParam, //  ,     
       LPARAM lParam ) //  ,     
{
  HDC hDC;  //  ,    
  PAINTSTRUCT PaintStruc; //     
  RECT Rect; //  
  POINT Point; //  
  static HPEN hPen; //   
  HPEN OldPen; //   
  char s[16];

  switch (Message)
  {
   case WM_CREATE  :
      hPen = CreatePen(PS_SOLID,5,RGB(0,0,150)); //  
      return 0;

   case WM_KEYDOWN:
       MessageBeep(0);
       sprintf(s,"%c %04d %04x",wParam,wParam,wParam);
       MessageBox(hWnd,s,"   :",MB_OK | MB_ICONASTERISK);
       return 0;

   case WM_PAINT   :
 		//       BeginPaint
      MessageBeep(0);
      hDC = BeginPaint(hWnd,&PaintStruc); //   
      GetClientRect(hWnd,&Rect); //   
      OldPen = (HPEN) SelectObject (hDC,hPen); //   ,  
      // MoveToEx(hDC,0,0,&Point); LineTo(hDC,Rect.right,Rect.bottom); // 
      // MoveToEx(hDC,0,Rect.bottom,&Point); LineTo(hDC,Rect.right,0); //  
      Ellipse(hDC,0,0,Rect.right,Rect.bottom);
      SelectObject(hDC,OldPen); //   
 		EndPaint(hWnd,&PaintStruc); //  
      return 0; //  0,    

   case WM_DESTROY :
      DeleteObject(hPen); //    
      PostQuitMessage(0); //     WM_QUIT
   	return 0;           //   ,    0

   default :
     //      :
     return DefWindowProc(hWnd,Message,wParam,lParam);
  }
}

